#include "game.h"
#include "map.h"
#include <string.h>

void
game_init(Game *this)
{
	memset(this, 0, sizeof(*this));
}

void
game_deinit(Game *this)
{
	(void)this;
}

void
game_update(Game *this)
{
	for (int i = 0; i < MAX_ENTITIES; i++) {
		Entity *const e = &this->entities[i];
		if (e->type != ET_NONE && e->update != NULL)
			e->update(e, this);
	}
}

void
game_draw(Game *this)
{
	map_draw();
	for (int i = 0; i < MAX_ENTITIES; i++) {
		Entity *const e = &this->entities[i];
		if (e->type != ET_NONE && e->draw != NULL)
			e->draw(e, this);
	}
}

Entity *
game_create_entity(Game *this)
{
	Entity *e = &this->entities[MAX_ENTITIES - 1];
	for (int i = 0; i < MAX_ENTITIES; i++)
		if (this->entities[i].type == ET_NONE) {
			e = &this->entities[i];
			break;
		}
	e->type = ET_NONE;
	e->uuid = this->uuid;
	this->uuid += 1;
	return e;
}
