#include "map.h"
#include "lzy.h"
#include "cfg.h"

static const char *map =
	"0000000000000000000000000"
	"0                       0"
	"0                       0"
	"0                       0"
	"0                       0"
	"0                       0"
	"0                       0"
	"0                       0"
	"0                       0"
	"0                     0 0"
	"00000000000000000000    0"
	"0                       0"
	"0                     0 0"
	"0000000000000000000000000"
;

int
map_get(int x, int y)
{
	if (x < 0 || y < 0 || x >= 25 || y >= 14)
		return 0;
	return map[x + y * 25];
}

int
map_get_px(int x, int y)
{
	if (x < 0 || y < 0)
		return 0;
	return map_get(x / TSIZE, y / TSIZE);
}

void
map_draw(void)
{
	for (int y = 0; y < 14; y++)
		for (int x = 0; x < 25; x++)
			if (map[x + y * 25] == '0') {
				LZY_DrawSetColor(BLACK);
				LZY_DrawRect(x*16, y*16, 16, 16);
				LZY_DrawFillRect(x*16, y*16, 16, 16);
			}
}
